Whamcloud - gitweb
LU-4322 tests: re-enable 101a in dne config
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 5572cc9..2736f42 100644 (file)
@@ -41,8 +41,8 @@ init_logging
 ALWAYS_EXCEPT="$SANITY_EXCEPT "
 # bug number for skipped test: LU-9693 LU-6493 LU-9693
 ALWAYS_EXCEPT+="               42a     42b     42c "
-# bug number:    LU-8411 LU-9096 LU-9054
-ALWAYS_EXCEPT+=" 407     253     312 "
+# bug number:    LU-8411 LU-9054
+ALWAYS_EXCEPT+=" 407     312 "
 
 if $SHARED_KEY; then
        # bug number:    LU-9795 LU-9795 LU-9795 LU-9795
@@ -53,16 +53,16 @@ fi
 if [[ $(uname -m) = aarch64 ]]; then
        # bug number:    LU-11596
        ALWAYS_EXCEPT+=" $GRANT_CHECK_LIST"
-       # bug number:    LU-11671 LU-11594 LU-11667 LU-11729
-       ALWAYS_EXCEPT+=" 45       103a      317      810"
+       # bug number:    LU-11671 LU-11667 LU-4398
+       ALWAYS_EXCEPT+=" 45       317      817"
 fi
 
 #                                  5          12          (min)"
 [ "$SLOW" = "no" ] && EXCEPT_SLOW="27m 64b 68 71 115 300o"
 
 if [ "$mds1_FSTYPE" = "zfs" ]; then
-       # bug number for skipped test: LU-1957
-       ALWAYS_EXCEPT="$ALWAYS_EXCEPT  180"
+       # bug number for skipped test:
+       ALWAYS_EXCEPT="$ALWAYS_EXCEPT  "
        #                                               13    (min)"
        [ "$SLOW" = "no" ] && EXCEPT_SLOW="$EXCEPT_SLOW 51b"
 fi
@@ -1742,12 +1742,6 @@ test_27m() {
 }
 run_test 27m "create file while OST0 was full"
 
-sleep_maxage() {
-       local delay=$(do_facet $SINGLEMDS lctl get_param -n lov.*.qos_maxage |
-                     awk '{ print $1 * 2; exit; }')
-       sleep $delay
-}
-
 # OSCs keep a NOSPC flag that will be reset after ~5s (qos_maxage)
 # if the OST isn't full anymore.
 reset_enospc() {
@@ -1777,12 +1771,12 @@ exhaust_precreations() {
        # on the mdt's osc
        local mdtosc_proc1=$(get_mdtosc_proc_path $mfacet $OST)
        local last_id=$(do_facet $mfacet lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_last_id)
+                       osp.$mdtosc_proc1.prealloc_last_id)
        local next_id=$(do_facet $mfacet lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_next_id)
+                       osp.$mdtosc_proc1.prealloc_next_id)
 
        local mdtosc_proc2=$(get_mdtosc_proc_path $mfacet)
-       do_facet $mfacet lctl get_param osc.$mdtosc_proc2.prealloc*
+       do_facet $mfacet lctl get_param osp.$mdtosc_proc2.prealloc*
 
        test_mkdir -p $DIR/$tdir/${OST}
        $LFS setstripe -i $OSTIDX -c 1 $DIR/$tdir/${OST}
@@ -1790,7 +1784,7 @@ exhaust_precreations() {
        do_facet $ofacet lctl set_param fail_val=$FAILIDX fail_loc=0x215
        echo "Creating to objid $last_id on ost $OST..."
        createmany -o $DIR/$tdir/${OST}/f $next_id $((last_id - next_id + 2))
-       do_facet $mfacet lctl get_param osc.$mdtosc_proc2.prealloc*
+       do_facet $mfacet lctl get_param osp.$mdtosc_proc2.prealloc*
        do_facet $ofacet lctl set_param fail_loc=$FAILLOC
        sleep_maxage
 }
@@ -2033,9 +2027,9 @@ test_27y() {
 
        local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $FSNAME-OST0000)
        local last_id=$(do_facet $SINGLEMDS lctl get_param -n \
-               osc.$mdtosc.prealloc_last_id)
+               osp.$mdtosc.prealloc_last_id)
        local next_id=$(do_facet $SINGLEMDS lctl get_param -n \
-               osc.$mdtosc.prealloc_next_id)
+               osp.$mdtosc.prealloc_next_id)
        local fcount=$((last_id - next_id))
        [[ $fcount -eq 0 ]] && skip "not enough space on OST0"
        [[ $fcount -gt $OSTCOUNT ]] && fcount=$OSTCOUNT
@@ -2464,10 +2458,6 @@ test_27D() {
        local ost_list=$(seq $first_ost $ost_step $last_ost)
        local ost_range="$first_ost $last_ost $ost_step"
 
-       if ! combined_mgs_mds ; then
-               mount_mgs_client
-       fi
-
        test_mkdir $DIR/$tdir
        pool_add $POOL || error "pool_add failed"
        pool_add_targets $POOL $ost_range || error "pool_add_targets failed"
@@ -2478,6 +2468,8 @@ test_27D() {
        [ $MDS1_VERSION -lt $(version_code 2.9.55) ] ||
                [ $CLIENT_VERSION -lt $(version_code 2.9.55) ] &&
                        skip27D+=" -s 30,31"
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code $SEL_VER) ] &&
+               skip27D+="-s 32"
        [[ ! $($LCTL get_param mdc.*.import) =~ connect_flags.*overstriping ||
          $OSTCOUNT -ge $(($LOV_MAX_STRIPE_COUNT / 2)) ]] &&
                skip27D+=" -s 32,33"
@@ -2485,10 +2477,6 @@ test_27D() {
                error "llapi_layout_test failed"
 
        destroy_test_pools || error "destroy test pools failed"
-
-       if ! combined_mgs_mds ; then
-               umount_mgs_client
-       fi
 }
 run_test 27D "validate llapi_layout API"
 
@@ -2814,6 +2802,165 @@ test_27K() {
 }
 run_test 27K "basic ops on dir with foreign LMV"
 
+test_27L() {
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+
+       local POOL=${POOL:-$TESTNAME}
+
+       pool_add $POOL || error "pool_add failed"
+
+       lfs pool_list $MOUNT | grep -Fx "${FSNAME}.${POOL}" ||
+                error "pool_list does not contain ${FSNAME}.${POOL}:" \
+                      "$(lfs pool_list $MOUNT | grep -F "${POOL}")"
+}
+run_test 27L "lfs pool_list gives correct pool name"
+
+test_27M() {
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.12.57) ]] &&
+               skip "Need MDS version >= than 2.12.57"
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ $OSTCOUNT -lt 2 ]] && skip_env "need > 1 OST"
+
+       test_mkdir $DIR/$tdir
+
+       # Set default striping on directory
+       $LFS setstripe -C 4 $DIR/$tdir
+
+       echo 1 > $DIR/$tdir/${tfile}.1
+       local count=$($LFS getstripe -c $DIR/$tdir/${tfile}.1)
+       local setcount=4
+       [ $count -eq $setcount ] ||
+               error "(1) stripe count $count, should be $setcount"
+
+       # Capture existing append_stripe_count setting for restore
+       local orig_count=$(do_facet mds1 $LCTL get_param -n mdd.$FSNAME-MDT0000.append_stripe_count)
+       local mdts=$(comma_list $(mdts_nodes))
+       stack_trap "do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=$orig_count" EXIT
+
+       local appendcount=$orig_count
+       echo 1 >> $DIR/$tdir/${tfile}.2_append
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.2_append)
+       [ $count -eq $appendcount ] ||
+               error "(2)stripe count $count, should be $appendcount for append"
+
+       # Disable O_APPEND striping, verify it works
+       do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=0
+
+       # Should now get the default striping, which is 4
+       setcount=4
+       echo 1 >> $DIR/$tdir/${tfile}.3_append
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.3_append)
+       [ $count -eq $setcount ] ||
+               error "(3) stripe count $count, should be $setcount"
+
+       # Try changing the stripe count for append files
+       do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=2
+
+       # Append striping is now 2 (directory default is still 4)
+       appendcount=2
+       echo 1 >> $DIR/$tdir/${tfile}.4_append
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.4_append)
+       [ $count -eq $appendcount ] ||
+               error "(4) stripe count $count, should be $appendcount for append"
+
+       # Test append stripe count of -1
+       do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=-1
+       appendcount=$OSTCOUNT
+       echo 1 >> $DIR/$tdir/${tfile}.5
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.5)
+       [ $count -eq $appendcount ] ||
+               error "(5) stripe count $count, should be $appendcount for append"
+
+       # Set append striping back to default of 1
+       do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=1
+
+       # Try a new default striping, PFL + DOM
+       $LFS setstripe -L mdt -E 1M -E -1 -c 2 $DIR/$tdir
+
+       # Create normal DOM file, DOM returns stripe count == 0
+       setcount=0
+       touch $DIR/$tdir/${tfile}.6
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.6)
+       [ $count -eq $setcount ] ||
+               error "(6) stripe count $count, should be $setcount"
+
+       # Show
+       appendcount=1
+       echo 1 >> $DIR/$tdir/${tfile}.7_append
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.7_append)
+       [ $count -eq $appendcount ] ||
+               error "(7) stripe count $count, should be $appendcount for append"
+
+       # Clean up DOM layout
+       $LFS setstripe -d $DIR/$tdir
+
+       # Now test that append striping works when layout is from root
+       $LFS setstripe -c 2 $MOUNT
+       # Make a special directory for this
+       mkdir $DIR/${tdir}/${tdir}.2
+       stack_trap "$LFS setstripe -d $MOUNT" EXIT
+
+       # Verify for normal file
+       setcount=2
+       echo 1 > $DIR/${tdir}/${tdir}.2/${tfile}.8
+       count=$($LFS getstripe -c $DIR/$tdir/${tdir}.2/${tfile}.8)
+       [ $count -eq $setcount ] ||
+               error "(8) stripe count $count, should be $setcount"
+
+       appendcount=1
+       echo 1 >> $DIR/${tdir}/${tdir}.2/${tfile}.9_append
+       count=$($LFS getstripe -c $DIR/${tdir}/${tdir}.2/${tfile}.9_append)
+       [ $count -eq $appendcount ] ||
+               error "(9) stripe count $count, should be $appendcount for append"
+
+       # Now test O_APPEND striping with pools
+       do_nodes $mdts $LCTL set_param mdd.*.append_pool="$TESTNAME"
+       stack_trap "do_nodes $mdts $LCTL set_param mdd.*.append_pool='none'" EXIT
+
+       # Create the pool
+       pool_add $TESTNAME || error "pool creation failed"
+       pool_add_targets $TESTNAME 0 1 || error "Pool add targets failed"
+
+       echo 1 >> $DIR/$tdir/${tfile}.10_append
+
+       pool=$($LFS getstripe -p $DIR/$tdir/${tfile}.10_append)
+       [ "$pool" = "$TESTNAME" ] || error "(10) incorrect pool: $pool"
+
+       # Check that count is still correct
+       appendcount=1
+       echo 1 >> $DIR/$tdir/${tfile}.11_append
+       count=$($LFS getstripe -c $DIR/$tdir/${tfile}.11_append)
+       [ $count -eq $appendcount ] ||
+               error "(11) stripe count $count, should be $appendcount for append"
+
+       # Disable O_APPEND stripe count, verify pool works separately
+       do_nodes $mdts $LCTL set_param mdd.*.append_stripe_count=0
+
+       echo 1 >> $DIR/$tdir/${tfile}.12_append
+
+       pool=$($LFS getstripe -p $DIR/$tdir/${tfile}.12_append)
+       [ "$pool" = "$TESTNAME" ] || error "(12) incorrect pool: $pool"
+
+       # Remove pool setting, verify it's not applied
+       do_nodes $mdts $LCTL set_param mdd.*.append_pool='none'
+
+       echo 1 >> $DIR/$tdir/${tfile}.13_append
+
+       pool=$($LFS getstripe -p $DIR/$tdir/${tfile}.13_append)
+       [ "$pool" = "" ] || error "(13) pool found: $pool"
+}
+run_test 27M "test O_APPEND striping"
+
+test_27N() {
+       combined_mgs_mds && skip "needs separate MGS/MDT"
+
+       pool_add $TESTNAME || error "pool_add failed"
+       do_facet mgs "$LCTL pool_list $FSNAME" |
+               grep -Fx "${FSNAME}.${TESTNAME}" ||
+               error "lctl pool_list on MGS failed"
+}
+run_test 27N "lctl pool_list on separate MGS gives correct pool name"
+
 # createtest also checks that device nodes are created and
 # then visible correctly (#2091)
 test_28() { # bug 2091
@@ -3068,10 +3215,10 @@ test_31n() {
 run_test 31n "check link count of unlinked file"
 
 link_one() {
-       local TEMPNAME=$(mktemp $1_XXXXXX)
-       mlink $TEMPNAME $1 2> /dev/null &&
-               echo "$BASHPID: link $TEMPNAME to $1 succeeded"
-       munlink $TEMPNAME
+       local tempfile=$(mktemp $1_XXXXXX)
+       mlink $tempfile $1 2> /dev/null &&
+               echo "$BASHPID: link $tempfile to $1 succeeded"
+       munlink $tempfile
 }
 
 test_31o() { # LU-2901
@@ -4119,7 +4266,7 @@ test_39j() {
                        error "mtime is lost on close: $mtime2, " \
                              "should be $mtime1"
 
-               cancel_lru_locks $OSC
+               cancel_lru_locks
                if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
        done
        lctl set_param fail_loc=0
@@ -4148,7 +4295,7 @@ test_39k() {
                [ "$mtime2" = $TEST_39_MTIME ] || \
                        error "mtime is lost on close: $mtime2, should be $TEST_39_MTIME"
 
-               cancel_lru_locks osc
+               cancel_lru_locks
                if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
        done
 }
@@ -5099,7 +5246,7 @@ test_53() {
        local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS)
        local value
        for value in $(do_facet $SINGLEMDS \
-                      $LCTL get_param osc.$mdtosc.prealloc_last_id) ; do
+                      $LCTL get_param osp.$mdtosc.prealloc_last_id) ; do
                param=$(echo ${value[0]} | cut -d "=" -f1)
                ostname=$(echo $param | cut -d "." -f2 | cut -d - -f 1-2)
 
@@ -5635,39 +5782,73 @@ test_56r() {
        setup_56 $dir $NUMFILES $NUMDIRS
 
        local expected=12
-       local cmd="$LFS find -size 0 -type f $dir"
+       local cmd="$LFS find -size 0 -type f -lazy $dir"
        local nums=$($cmd | wc -l)
 
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+       cmd="$LFS find -size 0 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+
        expected=0
+       cmd="$LFS find ! -size 0 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find ! -size 0 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+
        echo "test" > $dir/$tfile
        echo "test2" > $dir/$tfile.2 && sync
        expected=1
+       cmd="$LFS find -size 5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find -size 5 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+
        expected=1
+       cmd="$LFS find -size +5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find -size +5 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+
        expected=2
+       cmd="$LFS find -size +0 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find -size +0 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+
        expected=2
+       cmd="$LFS find ! -size -5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find ! -size -5 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
                error "'$cmd' wrong: found $nums, expected $expected"
+
        expected=12
+       cmd="$LFS find -size -5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
        cmd="$LFS find -size -5 -type f $dir"
        nums=$($cmd | wc -l)
        [ $nums -eq $expected ] ||
@@ -5675,6 +5856,155 @@ test_56r() {
 }
 run_test 56r "check lfs find -size works"
 
+test_56ra() {
+       local dir=$DIR/$tdir
+
+       [[ $OSC == "mdc" ]] && skip "DoM files" && return
+
+       setup_56 $dir $NUMFILES $NUMDIRS "-c 1"
+
+       cancel_lru_locks $OSC
+
+       local rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       local expected=12
+       local cmd="$LFS find -size 0 -type f -lazy $dir"
+       local nums=$($cmd | wc -l)
+
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+
+       local rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find -size 0 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       $LCTL get_param osc.*.stats
+       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
+               error "'$cmd' should send 12 glimpse RPCs to OST"
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=0
+       cmd="$LFS find ! -size 0 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       $LCTL get_param mdc.*.stats
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find ! -size 0 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 12)) ] ||
+               error "'$cmd' should send 12 glimpse RPCs to OST"
+
+       echo "test" > $dir/$tfile
+       echo "test2" > $dir/$tfile.2 && sync
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=1
+       cmd="$LFS find -size 5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find -size 5 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
+               error "'$cmd' should send 14 glimpse RPCs to OST"
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=1
+       cmd="$LFS find -size +5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find -size +5 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
+               error "'$cmd' should send 14 glimpse RPCs to OST"
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=2
+       cmd="$LFS find -size +0 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find -size +0 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
+               error "'$cmd' should send 14 glimpse RPCs to OST"
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=2
+       cmd="$LFS find ! -size -5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find ! -size -5 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
+               error "'$cmd' should send 14 glimpse RPCs to OST"
+
+       cancel_lru_locks $OSC
+       rpcs_before=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       expected=12
+       cmd="$LFS find -size -5 -type f -lazy $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       [ $rpcs_before -eq $rpcs_after ] ||
+               error "'$cmd' should not send glimpse RPCs to OST"
+       cmd="$LFS find -size -5 -type f $dir"
+       nums=$($cmd | wc -l)
+       [ $nums -eq $expected ] ||
+               error "'$cmd' wrong: found $nums, expected $expected"
+       rpcs_after=$(calc_stats $OSC.*$OSC*.stats ldlm_glimpse_enqueue)
+       echo "Before: $rpcs_before After: $rpcs_after $NUMFILES"
+       [ $rpcs_after -eq $((rpcs_before + 14)) ] ||
+               error "'$cmd' should send 14 glimpse RPCs to OST"
+}
+run_test 56ra "check lfs find -size -lazy works for data on OSTs"
+
 test_56s() { # LU-611 #LU-9369
        [[ $OSTCOUNT -lt 2 ]] && skip_env "need at least 2 OSTs"
 
@@ -6298,7 +6628,7 @@ check_migrate_links() {
        # make sure hard links were properly detected, and migration was
        # performed only once for the entire link set; nonlinked files should
        # also be migrated
-       local actual=$(grep -c 'done migrate' <<< "$migrate_out")
+       local actual=$(grep -c 'done' <<< "$migrate_out")
        local expected=$(($uniq_count + 1))
 
        [ "$actual" -eq  "$expected" ] ||
@@ -6349,13 +6679,14 @@ test_56xc() {
 
        # Test 1: ensure file < 1 GB is always migrated with 1 stripe
        echo -n "Setting initial stripe for 20MB test file..."
-       $LFS setstripe -c 2 -i 0 "$dir/20mb" || error "cannot setstripe"
+       $LFS setstripe -c 2 -i 0 "$dir/20mb" ||
+               error "cannot setstripe 20MB file"
        echo "done"
        echo -n "Sizing 20MB test file..."
        truncate "$dir/20mb" 20971520 || error "cannot create 20MB test file"
        echo "done"
        echo -n "Verifying small file autostripe count is 1..."
-       $LFS_MIGRATE -y -A -C 1 "$dir/20mb" &> /dev/null ||
+       $LFS_MIGRATE -y -A -C 1 "$dir/20mb" ||
                error "cannot migrate 20MB file"
        local stripe_count=$($LFS getstripe -c "$dir/20mb") ||
                error "cannot get stripe for $dir/20mb"
@@ -6368,24 +6699,28 @@ test_56xc() {
        # sqrt(size_in_gb) + 1 OSTs but is larger than 1GB.  The file must
        # have at least an additional 1KB for each desired stripe for test 3
        echo -n "Setting stripe for 1GB test file..."
-       $LFS setstripe -c 1 -i 0 "$dir/1gb" || error "cannot setstripe"
+       $LFS setstripe -c 1 -i 0 "$dir/1gb" || error "cannot setstripe 1GB file"
        echo "done"
        echo -n "Sizing 1GB test file..."
        # File size is 1GB + 3KB
-       truncate "$dir/1gb" 1073744896 &> /dev/null ||
-               error "cannot create 1GB test file"
-       echo "done"
-       echo -n "Migrating 1GB file..."
-       $LFS_MIGRATE -y -A -C 1 "$dir/1gb" &> /dev/null ||
-               error "cannot migrate file"
-       echo "done"
-       echo -n "Verifying autostripe count is sqrt(n) + 1..."
-       stripe_count=$($LFS getstripe -c "$dir/1gb") ||
-               error "cannot get stripe for $dir/1gb"
-       [ $stripe_count -eq 2 ] ||
-               error "unexpected stripe count $stripe_count (expected 2)"
+       truncate "$dir/1gb" 1073744896 || error "cannot create 1GB test file"
        echo "done"
 
+       # need at least 512MB per OST for 1GB file to fit in 2 stripes
+       local avail=$($LCTL get_param -n llite.$FSNAME*.kbytesavail)
+       if (( avail > 524288 * OSTCOUNT )); then
+               echo -n "Migrating 1GB file..."
+               $LFS_MIGRATE -y -A -C 1 "$dir/1gb" ||
+                       error "cannot migrate 1GB file"
+               echo "done"
+               echo -n "Verifying autostripe count is sqrt(n) + 1..."
+               stripe_count=$($LFS getstripe -c "$dir/1gb") ||
+                       error "cannot getstripe for 1GB file"
+               [ $stripe_count -eq 2 ] ||
+                       error "unexpected stripe count $stripe_count != 2"
+               echo "done"
+       fi
+
        # Test 3: File is too large to fit within the available space on
        # sqrt(n) + 1 OSTs.  Simulate limited available space with -X
        if [ $OSTCOUNT -ge 3 ]; then
@@ -6393,15 +6728,15 @@ test_56xc() {
                # file size (1GB + 3KB) / OST count (3).
                local kb_per_ost=349526
 
-               echo -n "Migrating 1GB file..."
-               $LFS_MIGRATE -y -A -C 1 -X $kb_per_ost "$dir/1gb" &>> \
-                       /dev/null || error "cannot migrate file"
+               echo -n "Migrating 1GB file with limit..."
+               $LFS_MIGRATE -y -A -C 1 -X $kb_per_ost "$dir/1gb" ||
+                       error "cannot migrate 1GB file with limit"
                echo "done"
 
                stripe_count=$($LFS getstripe -c "$dir/1gb")
-               echo -n "Verifying autostripe count with limited space..."
-               [ "$stripe_count" -a $stripe_count -eq 3 ] ||
-                       error "unexpected stripe count $stripe_count (wanted 3)"
+               echo -n "Verifying 1GB autostripe count with limited space..."
+               [ "$stripe_count" -a $stripe_count -ge 3 ] ||
+                       error "unexpected stripe count $stripe_count (min 3)"
                echo "done"
        fi
 
@@ -6452,18 +6787,20 @@ test_56z() { # LU-4824
        test_mkdir $dir
        for i in d{0..9}; do
                test_mkdir $dir/$i
+               touch $dir/$i/$tfile
        done
-       touch $dir/d{0..9}/$tfile
        $LFS find $DIR/non_existent_dir $dir &&
                error "$LFS find did not return an error"
        # Make a directory unsearchable. This should NOT be the last entry in
        # directory order.  Arbitrarily pick the 6th entry
        chmod 700 $($LFS find $dir -type d | sed '6!d')
 
+       $RUNAS $LFS find $DIR/non_existent $dir
        local count=$($RUNAS $LFS find $DIR/non_existent $dir | wc -l)
 
        # The user should be able to see 10 directories and 9 files
-       [ $count == 19 ] || error "$LFS find did not continue after error"
+       (( count == 19 )) ||
+               error "$LFS find found $count != 19 entries after error"
 }
 run_test 56z "lfs find should continue after an error"
 
@@ -6786,9 +7123,9 @@ test_60a() {
        local pass=true
 
        #get fid and record list
-       fid_list=($(awk '/9_sub.*record/ { print $NF }' /$TMP/$tfile |
+       fid_list=($(awk '/9_sub.*record/ { print $NF }' $TMP/$tfile |
                tail -n 4))
-       rec_list=($(awk '/9_sub.*record/ { print $((NF-3)) }' /$TMP/$tfile |
+       rec_list=($(awk '/9_sub.*record/ { print $((NF-3)) }' $TMP/$tfile |
                tail -n 4))
        #remount mgs as ldiskfs or zfs type
        stop mgs || error "stop mgs failed"
@@ -6907,13 +7244,16 @@ run_test 60e "no space while new llog is being created"
 
 test_60g() {
        local pid
+       local i
 
        test_mkdir -c $MDSCOUNT $DIR/$tdir
-       $LFS setdirstripe -D -i -1 -c $MDSCOUNT $DIR/$tdir
 
        (
                local index=0
                while true; do
+                       $LFS setdirstripe -i $(($index % $MDSCOUNT)) \
+                               -c $MDSCOUNT $DIR/$tdir/subdir$index \
+                               2>/dev/null
                        mkdir $DIR/$tdir/subdir$index 2>/dev/null
                        rmdir $DIR/$tdir/subdir$index 2>/dev/null
                        index=$((index + 1))
@@ -6922,23 +7262,41 @@ test_60g() {
 
        pid=$!
 
-       for i in $(seq 100); do 
+       for i in {0..100}; do
                # define OBD_FAIL_OSD_TXN_START    0x19a
-               do_facet mds1 lctl set_param fail_loc=0x8000019a
+               local index=$((i % MDSCOUNT + 1))
+
+               do_facet mds$index $LCTL set_param fail_loc=0x8000019a \
+                       > /dev/null
                usleep 100
        done
 
        kill -9 $pid
 
+       for i in $(seq $MDSCOUNT); do
+               do_facet mds$i $LCTL set_param fail_loc=0 > /dev/null
+       done
+
        mkdir $DIR/$tdir/new || error "mkdir failed"
        rmdir $DIR/$tdir/new || error "rmdir failed"
+
+       do_facet mds1 $LCTL lfsck_start -M $(facet_svc mds1) -A -C \
+               -t namespace
+       for i in $(seq $MDSCOUNT); do
+               wait_update_facet mds$i "$LCTL get_param -n \
+                       mdd.$(facet_svc mds$i).lfsck_namespace |
+                       awk '/^status/ { print \\\$2 }'" "completed"
+       done
+
+       ls -R $DIR/$tdir || error "ls failed"
+       rm -rf $DIR/$tdir || error "rmdir failed"
 }
 run_test 60g "transaction abort won't cause MDT hung"
 
 test_60h() {
-       [ $MDS1_VERSION -le $(version_code 2.12.52) ] ||
+       [ $MDS1_VERSION -le $(version_code 2.12.52) ] &&
                skip "Need MDS version at least 2.12.52"
-       [ $MDSCOUNT -le 2 ] || skip "Need >= 2 MDTs"
+       [ $MDSCOUNT -lt 2 ] && skip "Need at least 2 MDTs"
 
        local f
 
@@ -7307,7 +7665,7 @@ cleanup_65k() {
        do_facet $SINGLEMDS lctl --device  %$INACTIVE_OSC activate
        echo $INACTIVE_OSC "is Activate"
 
-       wait_osc_import_state mds ost$ostnum FULL
+       wait_osc_import_state mds ost$(( ostnum + 1 )) FULL
 }
 
 test_65k() { # bug11679
@@ -7367,7 +7725,7 @@ test_65k() { # bug11679
                do_facet $SINGLEMDS lctl --device  %$INACTIVE_OSC activate
                echo $INACTIVE_OSC "is Activate"
 
-               wait_osc_import_state mds ost$ostnum FULL
+               wait_osc_import_state mds ost$(( ostnum + 1 )) FULL
        done
 }
 run_test 65k "validate manual striping works properly with deactivated OSCs"
@@ -7483,6 +7841,29 @@ test_65n() {
        local dir5_layout=$(get_layout_param $dir5)
        [[ "$dir4_layout" = "$dir5_layout" ]] ||
                error "$dir5 should inherit the default layout from $dir4"
+
+       # though subdir under ROOT doesn't inherit default layout, but
+       # its sub dir/file should be created with default layout.
+       [[ $MDSCOUNT -ge 2 ]] || skip_env "needs >= 2 MDTs"
+       [[ $MDS1_VERSION -ge $(version_code 2.12.59) ]] ||
+               skip "Need MDS version at least 2.12.59"
+
+       local default_lmv_count=$($LFS getdirstripe -D -c $MOUNT)
+       local default_lmv_index=$($LFS getdirstripe -D -i $MOUNT)
+       local default_lmv_hash=$($LFS getdirstripe -D -H $MOUNT)
+
+       if [ $default_lmv_hash == "none" ]; then
+               stack_trap "$LFS setdirstripe -D -d $MOUNT" EXIT
+       else
+               stack_trap "$LFS setdirstripe -D -i $default_lmv_index \
+                       -c $default_lmv_count -H $default_lmv_hash $MOUNT" EXIT
+       fi
+
+       $LFS setdirstripe -D -c 2 $MOUNT ||
+               error "setdirstripe -D -c 2 failed"
+       mkdir $MOUNT/$tdir-6 || error "mkdir $tdir-6 failed"
+       local lmv_count=$($LFS getdirstripe -c $MOUNT/$tdir-6)
+       [ $lmv_count -eq 2 ] || error "$tdir-6 stripe count $lmv_count"
 }
 run_test 65n "don't inherit default layout from root for new subdirectories"
 
@@ -7726,9 +8107,22 @@ CKSUM_TYPES=${CKSUM_TYPES:-$(lctl get_param -n osc.*osc-[^mM]*.checksum_type |
 set_checksum_type()
 {
        lctl set_param -n osc.*osc-[^mM]*.checksum_type $1
-       log "set checksum type to $1"
-       return 0
+       rc=$?
+       log "set checksum type to $1, rc = $rc"
+       return $rc
+}
+
+get_osc_checksum_type()
+{
+       # arugment 1: OST name, like OST0000
+       ost=$1
+       checksum_type=$(lctl get_param -n osc.*${ost}-osc-[^mM]*.checksum_type |
+                       sed 's/.*\[\(.*\)\].*/\1/g')
+       rc=$?
+       [ $rc -ne 0 ] && error "failed to get checksum type of $ost, rc = $rc, output = $checksum_type"
+       echo $checksum_type
 }
+
 F77_TMP=$TMP/f77-temp
 F77SZ=8
 setup_f77() {
@@ -7957,7 +8351,7 @@ test_77k() { # LU-10906
                wait_update $HOSTNAME "$get_checksum" $i
                #remount
                echo "remount client, checksum should be $i"
-               remount_client $MOUNT || "failed to remount client"
+               remount_client $MOUNT || error "failed to remount client"
                checksum=$(eval $get_checksum)
                [ $checksum -eq $i ] || error "checksum($checksum) != $i"
        done
@@ -7968,18 +8362,50 @@ test_77k() { # LU-10906
        for opt in "checksum" "nochecksum"; do
                #remount with mount option
                echo "remount client with option $opt, checksum should be $i"
-               umount_client $MOUNT || "failed to umount client"
+               umount_client $MOUNT || error "failed to umount client"
                mount_client $MOUNT "$MOUNT_OPTS,$opt" ||
-                       "failed to mount client with option '$opt'"
+                       error "failed to mount client with option '$opt'"
                checksum=$(eval $get_checksum)
                [ $checksum -eq $i ] || error "checksum($checksum) != $i"
                i=$((i - 1))
        done
 
-       remount_client $MOUNT || "failed to remount client"
+       remount_client $MOUNT || error "failed to remount client"
 }
 run_test 77k "enable/disable checksum correctly"
 
+test_77l() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       $GSS && skip_env "could not run with gss"
+
+       set_checksums 1
+       stack_trap "set_checksums $ORIG_CSUM" EXIT
+       stack_trap "set_checksum_type $ORIG_CSUM_TYPE" EXIT
+
+       set_checksum_type invalid && error "unexpected success of invalid checksum type"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile
+       for algo in $CKSUM_TYPES; do
+               set_checksum_type $algo || error "fail to set checksum type $algo"
+               osc_algo=$(get_osc_checksum_type OST0000)
+               [ "$osc_algo" != "$algo" ] && error "checksum type is $osc_algo after setting it to $algo"
+
+               # no locks, no reqs to let the connection idle
+               cancel_lru_locks osc
+               lru_resize_disable osc
+               wait_osc_import_state client ost1 IDLE
+
+               # ensure ost1 is connected
+               stat $DIR/$tfile >/dev/null || error "can't stat"
+               wait_osc_import_state client ost1 FULL
+
+               osc_algo=$(get_osc_checksum_type OST0000)
+               [ "$osc_algo" != "$algo" ] && error "checksum type changed from $algo to $osc_algo after reconnection"
+       done
+       return 0
+}
+run_test 77l "preferred checksum type is remembered after reconnected"
+
 [ "$ORIG_CSUM" ] && set_checksums $ORIG_CSUM || true
 rm -f $F77_TMP
 unset F77_TMP
@@ -8241,7 +8667,6 @@ cleanup_101a() {
 
 test_101a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
-       [ $MDSCOUNT -ge 2 ] && skip_env "needs < 2 MDTs" #LU-4322
 
        local s
        local discard
@@ -8266,9 +8691,12 @@ test_101a() {
        done
        cleanup_101a
 
-       if [[ $(($discard * 10)) -gt $nreads ]]; then
-               $LCTL get_param osc.*-osc*.rpc_stats
-               $LCTL get_param llite.*.read_ahead_stats
+       $LCTL get_param osc.*-osc*.rpc_stats
+       $LCTL get_param llite.*.read_ahead_stats
+
+       # Discard is generally zero, but sometimes a few random reads line up
+       # and trigger larger readahead, which is wasted & leads to discards.
+       if [[ $(($discard)) -gt $nreads ]]; then
                error "too many ($discard) discarded pages"
        fi
        rm -f $DIR/$tfile || true
@@ -8378,12 +8806,14 @@ test_101c() {
        cancel_lru_locks osc
        $LCTL set_param osc.*.rpc_stats 0
        $READS -f $DIR/$tfile -s$FILE_LENGTH -b$rsize -n$nreads -t 180
+       $LCTL get_param osc.*.rpc_stats
        for osc_rpc_stats in $($LCTL get_param -N osc.*.rpc_stats); do
                local stats=$($LCTL get_param -n $osc_rpc_stats)
                local lines=$(echo "$stats" | awk 'END {print NR;}')
                local size
 
                if [ $lines -le 20 ]; then
+                       echo "continue debug"
                        continue
                fi
                for size in 1 2 4 8; do
@@ -8603,6 +9033,26 @@ test_101g() {
 }
 run_test 101g "Big bulk(4/16 MiB) readahead"
 
+test_101h() {
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile
+
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=70 ||
+               error "dd 70M file failed"
+       echo Cancel LRU locks on lustre client to flush the client cache
+       cancel_lru_locks osc
+
+       echo "Reset readahead stats"
+       $LCTL set_param -n llite.*.read_ahead_stats 0
+
+       echo "Read 10M of data but cross 64M bundary"
+       dd if=$DIR/$tfile of=/dev/null bs=10M skip=6 count=1
+       local miss=$($LCTL get_param -n llite.*.read_ahead_stats |
+                       get_named_value 'misses' | cut -d" " -f1 | calc_total)
+       [ $miss -eq 1 ] || error "expected miss 1 but got $miss"
+       rm -f $p $DIR/$tfile
+}
+run_test 101h "Readahead should cover current read window"
+
 setup_test102() {
        test_mkdir $DIR/$tdir
        chown $RUNAS_ID $DIR/$tdir
@@ -9589,7 +10039,7 @@ test_116a() { # was previously test_116()
        remote_mds_nodsh && skip "remote MDS with nodsh"
 
        echo -n "Free space priority "
-       do_facet $SINGLEMDS lctl get_param -n lo*.*-mdtlov.qos_prio_free |
+       do_facet $SINGLEMDS lctl get_param -n lo[vd].*-mdtlov.qos_prio_free |
                head -n1
        declare -a AVAIL
        free_min_max
@@ -9710,17 +10160,17 @@ test_116b() { # LU-2093
 
 #define OBD_FAIL_MDS_OSC_CREATE_FAIL     0x147
        local old_rr=$(do_facet $SINGLEMDS lctl get_param -n \
-                      lo*.$FSNAME-MDT0000-mdtlov.qos_threshold_rr | head -1)
+                      lo[vd].$FSNAME-MDT0000-mdtlov.qos_threshold_rr | head -1)
        [ -z "$old_rr" ] && skip "no QOS"
        do_facet $SINGLEMDS lctl set_param \
-               lo*.$FSNAME-MDT0000-mdtlov.qos_threshold_rr=0
+               lo[vd].$FSNAME-MDT0000-mdtlov.qos_threshold_rr=0
        mkdir -p $DIR/$tdir
        do_facet $SINGLEMDS lctl set_param fail_loc=0x147
        createmany -o $DIR/$tdir/f- 20 || error "can't create"
        do_facet $SINGLEMDS lctl set_param fail_loc=0
        rm -rf $DIR/$tdir
        do_facet $SINGLEMDS lctl set_param \
-               lo*.$FSNAME-MDT0000-mdtlov.qos_threshold_rr=$old_rr
+               lo[vd].$FSNAME-MDT0000-mdtlov.qos_threshold_rr=$old_rr
 }
 run_test 116b "QoS shouldn't LBUG if not enough OSTs found on the 2nd pass"
 
@@ -10819,32 +11269,73 @@ test_124c() {
 }
 run_test 124c "LRUR cancel very aged locks"
 
-test_125() { # 13358
-       $LCTL get_param -n llite.*.client_type | grep -q local ||
-               skip "must run as local client"
-       $LCTL get_param -n mdc.*-mdc-*.connect_flags | grep -q acl ||
-               skip_env "must have acl enabled"
-       [ -z "$(which setfacl)" ] && skip_env "must have setfacl tool"
+test_124d() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       $LCTL get_param -n mdc.*.connect_flags | grep -q lru_resize ||
+               skip_env "no lru resize on server"
 
-       test_mkdir $DIR/$tdir
-       $LFS setstripe -S 65536 -c -1 $DIR/$tdir || error "setstripe failed"
-       setfacl -R -m u:bin:rwx $DIR/$tdir || error "setfacl $DIR/$tdir failed"
-       ls -ld $DIR/$tdir || error "cannot access $DIR/$tdir"
-}
-run_test 125 "don't return EPROTO when a dir has a non-default striping and ACLs"
+       # cache ununsed locks on client
+       local nr=100
 
-test_126() { # bug 12829/13455
-       $GSS && skip_env "must run as gss disabled"
-       $LCTL get_param -n llite.*.client_type | grep -q local ||
-               skip "must run as local client"
-       [ "$UID" != 0 ] && skip "must run as root, not UID $UID"
+       lru_resize_disable mdc
+       stack_trap "lru_resize_enable mdc" EXIT
 
-       $RUNAS -u 0 -g 1 touch $DIR/$tfile || error "touch failed"
-       gid=`ls -n $DIR/$tfile | awk '{print $4}'`
-       rm -f $DIR/$tfile
-       [ $gid -eq "1" ] || error "gid is set to" $gid "instead of 1"
-}
-run_test 126 "check that the fsgid provided by the client is taken into account"
+       cancel_lru_locks mdc
+
+       # asynchronous object destroy at MDT could cause bl ast to client
+       test_mkdir $DIR/$tdir
+       createmany -o $DIR/$tdir/f $nr ||
+               error "failed to create $nr files in $DIR/$tdir"
+       stack_trap "unlinkmany $DIR/$tdir/f $nr" EXIT
+
+       ls -l $DIR/$tdir > /dev/null
+
+       local nsdir="ldlm.namespaces.*-MDT0000-mdc-*"
+       local unused=$($LCTL get_param -n $nsdir.lock_unused_count)
+       local max_age=$($LCTL get_param -n $nsdir.lru_max_age)
+       local recalc_p=$($LCTL get_param -n $nsdir.pool.recalc_period)
+
+       echo "unused=$unused, max_age=$max_age, recalc_p=$recalc_p"
+
+       # set lru_max_age to 1 sec
+       $LCTL set_param $nsdir.lru_max_age=1000 # milliseconds
+       stack_trap "$LCTL set_param -n $nsdir.lru_max_age $max_age" EXIT
+
+       echo "sleep $((recalc_p * 2)) seconds..."
+       sleep $((recalc_p * 2))
+
+       local remaining=$($LCTL get_param -n $nsdir.lock_unused_count)
+
+       [ $remaining -eq 0 ] || error "$remaining locks are not canceled"
+}
+run_test 124d "cancel very aged locks if lru-resize diasbaled"
+
+test_125() { # 13358
+       $LCTL get_param -n llite.*.client_type | grep -q local ||
+               skip "must run as local client"
+       $LCTL get_param -n mdc.*-mdc-*.connect_flags | grep -q acl ||
+               skip_env "must have acl enabled"
+       [ -z "$(which setfacl)" ] && skip_env "must have setfacl tool"
+
+       test_mkdir $DIR/$tdir
+       $LFS setstripe -S 65536 -c -1 $DIR/$tdir || error "setstripe failed"
+       setfacl -R -m u:bin:rwx $DIR/$tdir || error "setfacl $DIR/$tdir failed"
+       ls -ld $DIR/$tdir || error "cannot access $DIR/$tdir"
+}
+run_test 125 "don't return EPROTO when a dir has a non-default striping and ACLs"
+
+test_126() { # bug 12829/13455
+       $GSS && skip_env "must run as gss disabled"
+       $LCTL get_param -n llite.*.client_type | grep -q local ||
+               skip "must run as local client"
+       [ "$UID" != 0 ] && skip "must run as root, not UID $UID"
+
+       $RUNAS -u 0 -g 1 touch $DIR/$tfile || error "touch failed"
+       gid=`ls -n $DIR/$tfile | awk '{print $4}'`
+       rm -f $DIR/$tfile
+       [ $gid -eq "1" ] || error "gid is set to" $gid "instead of 1"
+}
+run_test 126 "check that the fsgid provided by the client is taken into account"
 
 test_127a() { # bug 15521
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -10937,6 +11428,75 @@ test_127b() { # bug LU-333
 }
 run_test 127b "verify the llite client stats are sane"
 
+test_127c() { # LU-12394
+       [ "$OSTCOUNT" -lt "2" ] && skip_env "needs >= 2 OSTs"
+       local size
+       local bsize
+       local reads
+       local writes
+       local count
+
+       $LCTL set_param llite.*.extents_stats=1
+       stack_trap "$LCTL set_param llite.*.extents_stats=0" EXIT
+
+       # Use two stripes so there is enough space in default config
+       $LFS setstripe -c 2 $DIR/$tfile
+
+       # Extent stats start at 0-4K and go in power of two buckets
+       # LL_HIST_START = 12 --> 2^12 = 4K
+       # We do 3K*2^i, so 3K, 6K, 12K, 24K... hitting each bucket.
+       # We do not do buckets larger than 64 MiB to avoid ENOSPC issues on
+       # small configs
+       for size in 3K 6K 12K 24K 48K 96K 192K 384K 768K 1536K 3M 6M 12M 24M 48M;
+               do
+               # Write and read, 2x each, second time at a non-zero offset
+               dd if=/dev/zero of=$DIR/$tfile bs=$size count=1
+               dd if=/dev/zero of=$DIR/$tfile bs=$size count=1 seek=10
+               dd if=$DIR/$tfile of=/dev/null bs=$size count=1
+               dd if=$DIR/$tfile of=/dev/null bs=$size count=1 seek=10
+               rm -f $DIR/$tfile
+       done
+
+       $LCTL get_param llite.*.extents_stats
+
+       count=2
+       for bsize in 4K 8K 16K 32K 64K 128K 256K 512K 1M 2M 4M 8M 16M 32M 64M;
+               do
+               local bucket=$($LCTL get_param -n llite.*.extents_stats |
+                               grep -m 1 $bsize)
+               reads=$(echo $bucket | awk '{print $5}')
+               writes=$(echo $bucket | awk '{print $9}')
+               [ "$reads" -eq $count ] ||
+                       error "$reads reads in < $bsize bucket, expect $count"
+               [ "$writes" -eq $count ] ||
+                       error "$writes writes in < $bsize bucket, expect $count"
+       done
+
+       # Test mmap write and read
+       $LCTL set_param llite.*.extents_stats=c
+       size=512
+       dd if=/dev/zero of=$DIR/$tfile bs=${size}K count=1
+       $MULTIOP $DIR/$tfile OSMRUc || error "$MULTIOP $DIR/$tfile failed"
+       $MULTIOP $DIR/$tfile OSMWUc || error "$MULTIOP $DIR/$tfile failed"
+
+       $LCTL get_param llite.*.extents_stats
+
+       count=$(((size*1024) / PAGE_SIZE))
+
+       bsize=$((2 * PAGE_SIZE / 1024))K
+
+       bucket=$($LCTL get_param -n llite.*.extents_stats |
+                       grep -m 1 $bsize)
+       reads=$(echo $bucket | awk '{print $5}')
+       writes=$(echo $bucket | awk '{print $9}')
+       # mmap writes fault in the page first, creating an additonal read
+       [ "$reads" -eq $((2 * count)) ] ||
+               error "$reads reads in < $bsize bucket, expect $count"
+       [ "$writes" -eq $count ] ||
+               error "$writes writes in < $bsize bucket, expect $count"
+}
+run_test 127c "test llite extent stats with regular & mmap i/o"
+
 test_128() { # bug 15212
        touch $DIR/$tfile
        $LFS 2>&1 <<-EOF | tee $TMP/$tfile.log
@@ -13552,6 +14112,77 @@ test_160i() {
 }
 run_test 160i "changelog user register/unregister race"
 
+test_160j() {
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ $MDS1_VERSION -lt $(version_code 2.12.56) ]] &&
+               skip "Need MDS version at least 2.12.56"
+
+       mount_client $MOUNT2 || error "mount_client on $MOUNT2 failed"
+
+       changelog_register || error "first changelog_register failed"
+
+       # generate some changelog
+       test_mkdir -c $MDSCOUNT $DIR/$tdir || error "mkdir $tdir failed"
+       createmany -m $DIR/$tdir/${tfile}bis $((MDSCOUNT * 2)) ||
+               error "create $DIR/$tdir/${tfile}bis failed"
+
+       # open the changelog device
+       exec 3>/dev/changelog-$FSNAME-MDT0000
+       exec 4</dev/changelog-$FSNAME-MDT0000
+
+       # umount the first lustre mount
+       umount $MOUNT
+
+       # read changelog
+       cat <&4 >/dev/null || error "read changelog failed"
+
+       # clear changelog
+       local cl_user="${CL_USERS[$SINGLEMDS]%% *}"
+       changelog_users $SINGLEMDS | grep -q $cl_user ||
+               error "User $cl_user not found in changelog_users"
+
+       printf 'clear:'$cl_user':0' >&3
+
+       # close
+       exec 3>&-
+       exec 4<&-
+
+       # cleanup
+       changelog_deregister || error "changelog_deregister failed"
+
+       umount $MOUNT2
+       mount_client $MOUNT || error "mount_client on $MOUNT failed"
+}
+run_test 160j "client can be umounted  while its chanangelog is being used"
+
+test_160k() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+
+       mkdir -p $DIR/$tdir/1/1
+
+       changelog_register || error "changelog_register failed"
+       local cl_user="${CL_USERS[$SINGLEMDS]%% *}"
+
+       changelog_users $SINGLEMDS | grep -q $cl_user ||
+               error "User '$cl_user' not found in changelog_users"
+#define OBD_FAIL_MDS_CHANGELOG_REORDER 0x15d
+       do_facet mds1 $LCTL set_param fail_loc=0x8000015d fail_val=3
+       rmdir $DIR/$tdir/1/1 & sleep 1
+       mkdir $DIR/$tdir/2
+       touch $DIR/$tdir/2/2
+       rm -rf $DIR/$tdir/2
+
+       wait
+       sleep 4
+
+       changelog_dump | grep rmdir || error "rmdir not recorded"
+
+       rm -rf $DIR/$tdir
+       changelog_deregister
+}
+run_test 160k "Verify that changelog records are not lost"
+
 test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
@@ -13748,7 +14379,8 @@ test_161d() {
        ps -p $pid
        [[ $? -eq 0 ]] || error "create should be blocked"
 
-       local tempfile=$(mktemp)
+       local tempfile="$(mktemp --tmpdir $tfile.XXXXXX)"
+       stack_trap "rm -f $tempfile"
        fid=$(changelog_extract_field "CREAT" "$tfile" "t=")
        cat $MOUNT/.lustre/fid/$fid 2>/dev/null >$tempfile || error "cat failed"
        # some delay may occur during ChangeLog publishing and file read just
@@ -14410,6 +15042,41 @@ test_185() { # LU-2441
 }
 run_test 185 "Volatile file support"
 
+function create_check_volatile() {
+       local idx=$1
+       local tgt
+
+       $MULTIOP $MOUNT/.lustre/fid V${idx}Fw4096_c >&/tmp/${tfile}.fid &
+       local PID=$!
+       sleep 1
+       local FID=$(cat /tmp/${tfile}.fid)
+       [ "$FID" == "" ] && error "can't get FID for volatile"
+       $CHECKSTAT -t file $MOUNT/.lustre/fid/$FID || error "can't stat $FID"
+       tgt=$($LFS getstripe -m $MOUNT/.lustre/fid/$FID)
+       [ "$tgt" != "$idx" ] && error "wrong MDS $tgt, expected $idx"
+       kill -USR1 $PID
+       wait
+       sleep 1
+       cancel_lru_locks mdc # flush opencache
+       $CHECKSTAT -t file $MOUNT/.lustre/fid/$FID && error "can stat $FID"
+       return 0
+}
+
+test_185a(){
+       # LU-12516 - volatile creation via .lustre
+       [[ $MDS1_VERSION -ge $(version_code 2.12.55) ]] ||
+               skip "Need MDS version at least 2.3.55"
+
+       create_check_volatile 0
+       [ $MDSCOUNT -lt 2 ] && return 0
+
+       # DNE case
+       create_check_volatile 1
+
+       return 0
+}
+run_test 185a "Volatile file creation in .lustre/fid/"
+
 test_187a() {
        remote_mds_nodsh && skip "remote MDS with nodsh"
        [ $MDS1_VERSION -lt $(version_code 2.3.0) ] &&
@@ -14468,10 +15135,6 @@ test_200() {
        local subdir=$test_path/subdir
        local rc=0
 
-       if ! combined_mgs_mds ; then
-               mount_mgs_client
-       fi
-
        while : ; do
                # former test_200a test_200b
                pool_add $POOL                          || { rc=$? ; break; }
@@ -14505,9 +15168,6 @@ test_200() {
 
        destroy_test_pools
 
-       if ! combined_mgs_mds ; then
-               umount_mgs_client
-       fi
        return $rc
 }
 run_test 200 "OST pools"
@@ -15183,16 +15843,12 @@ test_220() { #LU-325
        # on the mdt's osc
        local mdtosc_proc1=$(get_mdtosc_proc_path $SINGLEMDS $OST)
        local last_id=$(do_facet $SINGLEMDS lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_last_id)
+                       osp.$mdtosc_proc1.prealloc_last_id)
        local next_id=$(do_facet $SINGLEMDS lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_next_id)
+                       osp.$mdtosc_proc1.prealloc_next_id)
 
        $LFS df -i
 
-       if ! combined_mgs_mds ; then
-               mount_mgs_client
-       fi
-
        do_facet ost$((OSTIDX + 1)) lctl set_param fail_val=-1
        #define OBD_FAIL_OST_ENOINO              0x229
        do_facet ost$((OSTIDX + 1)) lctl set_param fail_loc=0x229
@@ -15211,9 +15867,9 @@ test_220() { #LU-325
        createmany -o $DIR/$tdir/f $MDSOBJS || return 3
 
        local last_id2=$(do_facet mds${MDSIDX} lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_last_id)
+                       osp.$mdtosc_proc1.prealloc_last_id)
        local next_id2=$(do_facet mds${MDSIDX} lctl get_param -n \
-                       osc.$mdtosc_proc1.prealloc_next_id)
+                       osp.$mdtosc_proc1.prealloc_next_id)
 
        echo "after creation, last_id=$last_id2, next_id=$next_id2"
        $LFS df -i
@@ -15229,10 +15885,6 @@ test_220() { #LU-325
                error "$LCTL pool_destroy $FSNAME.$TESTNAME failed"
        echo "unlink $MDSOBJS files @$next_id..."
        unlinkmany $DIR/$tdir/f $MDSOBJS || error "unlinkmany failed"
-
-       if ! combined_mgs_mds ; then
-               umount_mgs_client
-       fi
 }
 run_test 220 "preallocated MDS objects still used if ENOSPC from OST"
 
@@ -16586,7 +17238,7 @@ test_243()
 }
 run_test 243 "various group lock tests"
 
-test_244()
+test_244a()
 {
        test_mkdir $DIR/$tdir
        dd if=/dev/zero of=$DIR/$tdir/$tfile bs=1M count=35
@@ -16594,7 +17246,26 @@ test_244()
                error "sendfile+grouplock failed"
        rm -rf $DIR/$tdir
 }
-run_test 244 "sendfile with group lock tests"
+run_test 244a "sendfile with group lock tests"
+
+test_244b()
+{
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+
+       local threads=50
+       local size=$((1024*1024))
+
+       test_mkdir $DIR/$tdir
+       for i in $(seq 1 $threads); do
+               local file=$DIR/$tdir/file_$((i / 10))
+               $MULTIOP $file OG1234w$size_$((i % 3))w$size_$((i % 4))g1234c &
+               local pids[$i]=$!
+       done
+       for i in $(seq 1 $threads); do
+               wait ${pids[$i]}
+       done
+}
+run_test 244b "multi-threaded write with group lock"
 
 test_245() {
        local flagname="multi_mod_rpcs"
@@ -16874,33 +17545,6 @@ test_252() {
 }
 run_test 252 "check lr_reader tool"
 
-test_253_fill_ost() {
-       local size_mb #how many MB should we write to pass watermark
-       local lwm=$3  #low watermark
-       local free_10mb #10% of free space
-
-       free_kb=$($LFS df $MOUNT | grep $1 | awk '{ print $4 }')
-       size_mb=$((free_kb / 1024 - lwm))
-       free_10mb=$((free_kb / 10240))
-       #If 10% of free space cross low watermark use it
-       if (( free_10mb > size_mb )); then
-               size_mb=$free_10mb
-       else
-               #At least we need to store 1.1 of difference between
-               #free space and low watermark
-               size_mb=$((size_mb + size_mb / 10))
-       fi
-       if (( lwm <= $((free_kb / 1024)) )) || [ ! -f $DIR/$tdir/1 ]; then
-               dd if=/dev/zero of=$DIR/$tdir/1 bs=1M count=$size_mb \
-                        oflag=append conv=notrunc
-       fi
-
-       sleep_maxage
-
-       free_kb=$($LFS df $MOUNT | grep $1 | awk '{ print $4 }')
-       echo "OST still has $((free_kb / 1024)) mbytes free"
-}
-
 test_253() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
        remote_mds_nodsh && skip "remote MDS with nodsh"
@@ -16908,9 +17552,8 @@ test_253() {
 
        local ostidx=0
        local rc=0
+       local ost_name=$(ostname_from_index $ostidx)
 
-       local ost_name=$($LFS osts |
-               sed -n 's/^'$ostidx': \(.*\)_UUID .*/\1/p')
        # on the mdt's osc
        local mdtosc_proc1=$(get_mdtosc_proc_path $SINGLEMDS $ost_name)
        do_facet $SINGLEMDS $LCTL get_param -n \
@@ -16922,60 +17565,42 @@ test_253() {
        wait_delete_completed
        mkdir $DIR/$tdir
 
-       local last_wm_h=$(do_facet $SINGLEMDS $LCTL get_param -n \
-                       osp.$mdtosc_proc1.reserved_mb_high)
-       local last_wm_l=$(do_facet $SINGLEMDS $LCTL get_param -n \
-                       osp.$mdtosc_proc1.reserved_mb_low)
-       echo "prev high watermark $last_wm_h, prev low watermark $last_wm_l"
+       pool_add $TESTNAME || error "Pool creation failed"
+       pool_add_targets $TESTNAME 0 || error "Pool add targets failed"
 
-       if ! combined_mgs_mds ; then
-               mount_mgs_client
-       fi
-       create_pool $FSNAME.$TESTNAME || error "Pool creation failed"
-       do_facet mgs $LCTL pool_add $FSNAME.$TESTNAME $ost_name ||
-               error "Adding $ost_name to pool failed"
-
-       # Wait for client to see a OST at pool
-       wait_update $HOSTNAME "$LCTL get_param -n
-               lov.$FSNAME-*.pools.$TESTNAME | sort -u |
-               grep $ost_name" "$ost_name""_UUID" $((TIMEOUT/2)) ||
-               error "Client can not see the pool"
        $LFS setstripe $DIR/$tdir -i $ostidx -c 1 -p $FSNAME.$TESTNAME ||
                error "Setstripe failed"
 
-       dd if=/dev/zero of=$DIR/$tdir/0 bs=1M count=10
-       local blocks=$($LFS df $MOUNT | grep $ost_name | awk '{ print $4 }')
-       echo "OST still has $((blocks/1024)) mbytes free"
+       dd if=/dev/zero of=$DIR/$tdir/$tfile.0 bs=1M count=10
 
-       local new_lwm=$((blocks/1024-10))
-       do_facet $SINGLEMDS $LCTL set_param \
-                       osp.$mdtosc_proc1.reserved_mb_high=$((new_lwm+5))
-       do_facet $SINGLEMDS $LCTL set_param \
-                       osp.$mdtosc_proc1.reserved_mb_low=$new_lwm
-
-       test_253_fill_ost $ost_name $mdtosc_proc1 $new_lwm
-
-       #First enospc could execute orphan deletion so repeat.
-       test_253_fill_ost $ost_name $mdtosc_proc1 $new_lwm
+       local wms=$(ost_watermarks_set_enospc $tfile $ostidx |
+                   grep "watermarks")
+       stack_trap "ost_watermarks_clear_enospc $tfile $ostidx $wms" EXIT
 
        local oa_status=$(do_facet $SINGLEMDS $LCTL get_param -n \
                        osp.$mdtosc_proc1.prealloc_status)
        echo "prealloc_status $oa_status"
 
-       dd if=/dev/zero of=$DIR/$tdir/2 bs=1M count=1 &&
+       dd if=/dev/zero of=$DIR/$tdir/$tfile.1 bs=1M count=1 &&
                error "File creation should fail"
+
        #object allocation was stopped, but we still able to append files
-       dd if=/dev/zero of=$DIR/$tdir/1 bs=1M seek=6 count=5 oflag=append ||
-               error "Append failed"
-       rm -f $DIR/$tdir/1 $DIR/$tdir/0 $DIR/$tdir/r*
+       dd if=/dev/zero of=$DIR/$tdir/$tfile.0 bs=1M seek=6 count=5 \
+               oflag=append || error "Append failed"
+
+       rm -f $DIR/$tdir/$tfile.0
+
+       # For this test, we want to delete the files we created to go out of
+       # space but leave the watermark, so we remain nearly out of space
+       ost_watermarks_enospc_delete_files $tfile $ostidx
 
        wait_delete_completed
 
        sleep_maxage
 
        for i in $(seq 10 12); do
-               dd if=/dev/zero of=$DIR/$tdir/$i bs=1M count=1 2>/dev/null ||
-                       error "File creation failed after rm";
+               dd if=/dev/zero of=$DIR/$tdir/$tfile.$i bs=1M count=1 \
+                       2>/dev/null || error "File creation failed after rm"
        done
 
        oa_status=$(do_facet $SINGLEMDS $LCTL get_param -n \
@@ -16985,20 +17610,6 @@ test_253() {
        if (( oa_status != 0 )); then
                error "Object allocation still disable after rm"
        fi
-       do_facet $SINGLEMDS $LCTL set_param \
-                       osp.$mdtosc_proc1.reserved_mb_high=$last_wm_h
-       do_facet $SINGLEMDS $LCTL set_param \
-                       osp.$mdtosc_proc1.reserved_mb_low=$last_wm_l
-
-
-       do_facet mgs $LCTL pool_remove $FSNAME.$TESTNAME $ost_name ||
-               error "Remove $ost_name from pool failed"
-       do_facet mgs $LCTL pool_destroy $FSNAME.$TESTNAME ||
-               error "Pool destroy fialed"
-
-       if ! combined_mgs_mds ; then
-               umount_mgs_client
-       fi
 }
 run_test 253 "Check object allocation limit"
 
@@ -17304,7 +17915,7 @@ run_test 255b "check 'lfs ladvise -a dontneed'"
 
 test_255c() {
        [ $OST1_VERSION -lt $(version_code 2.10.50) ] &&
-               skip "lustre < 2.10.53 does not support lockahead"
+               skip "lustre < 2.10.50 does not support lockahead"
 
        local count
        local new_count
@@ -17419,7 +18030,8 @@ test_256() {
 
        #after mount new plainllog is used
        touch $DIR/$tdir/{11..19}
-       local tmpfile=$(mktemp -u $tfile.XXXXXX)
+       local tmpfile="$(mktemp --tmpdir -u $tfile.XXXXXX)"
+       stack_trap "rm -f $tmpfile"
        cat_sl=$(do_facet $SINGLEMDS "sync; \
                 $DEBUGFS -c -R 'dump changelog_catalog $tmpfile' $mdt_dev; \
                 llog_reader $tmpfile | grep -c type=1064553b")
@@ -17431,7 +18043,7 @@ test_256() {
 
        cat_sl=$(do_facet $SINGLEMDS "sync; \
                 $DEBUGFS -c -R 'dump changelog_catalog $tmpfile' $mdt_dev; \
-                llog_reader $tmpfile | grep -c type=1064553b; rm -f $tmpfile")
+                llog_reader $tmpfile | grep -c type=1064553b")
 
        if (( cat_sl == 2 )); then
                error "Empty plain llog was not deleted from changelog catalog"
@@ -18055,8 +18667,8 @@ test_271f() {
        local mdtidx=$($LFS getstripe --mdt-index $DIR/$tdir)
 
        cancel_lru_locks mdc
-       dd if=/dev/urandom of=$tmp bs=200000 count=1
-       dd if=$tmp of=$dom bs=200000 count=1
+       dd if=/dev/urandom of=$tmp bs=265000 count=1
+       dd if=$tmp of=$dom bs=265000 count=1
        cancel_lru_locks mdc
        cat /etc/hosts >> $tmp
        lctl set_param -n mdc.*.stats=clear
@@ -18083,6 +18695,7 @@ test_271f() {
        local ra=$(get_mdc_stats $mdtidx req_active)
        local rw=$(get_mdc_stats $mdtidx req_waittime)
 
+       [ -z $num ] && num=0
        [ $num -eq 1 ] || error "expect 1 READ RPC, $num occured"
        [ $ra == $rw ] || error "$((ra - rw)) resend occured"
        echo "... DONE"
@@ -18162,12 +18775,12 @@ test_272b() {
 
        $LFS migrate -c2 $dom ||
                error "failed to migrate to the new composite layout"
-       [ $($LFS getstripe -L $dom) == 'mdt' ] &&
+       [ $($LFS getstripe -L $dom) != 'mdt' ] ||
                error "MDT stripe was not removed"
 
        cancel_lru_locks mdc
        local new_md5=$(md5sum $dom)
-       [ "$old_md5" != "$new_md5" ] &&
+       [ "$old_md5" == "$new_md5" ] ||
                error "$old_md5 != $new_md5"
 
        # Skip free space checks with ZFS
@@ -18207,7 +18820,7 @@ test_272c() {
 
        cancel_lru_locks mdc
        local new_md5=$(md5sum $dom)
-       [ "$old_md5" != "$new_md5" ] &&
+       [ "$old_md5" == "$new_md5" ] ||
                error "$old_md5 != $new_md5"
 
        # Skip free space checks with ZFS
@@ -18221,6 +18834,108 @@ test_272c() {
 }
 run_test 272c "DoM migration: DOM file to the OST-striped file (composite)"
 
+test_272d() {
+       [ $MDS1_VERSION -lt $(version_code 2.12.55) ] &&
+               skip "Need MDS version at least 2.12.55"
+
+       local dom=$DIR/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -E 1M -L mdt -E -1 -c1 $dom
+
+       local mdtidx=$($LFS getstripe -m $dom)
+       local mdtname=MDT$(printf %04x $mdtidx)
+       local facet=mds$((mdtidx + 1))
+
+       dd if=/dev/urandom of=$dom bs=2M count=1 oflag=direct ||
+               error "failed to write data into $dom"
+       local old_md5=$(md5sum $dom)
+       cancel_lru_locks mdc
+       local mdtfree1=$(do_facet $facet \
+               lctl get_param -n osd*.*$mdtname.kbytesfree)
+
+       $LFS mirror extend -N -E 2M -c1 -E -1 -c2 $dom ||
+               error "failed mirroring to the new composite layout"
+       $LFS mirror resync $dom ||
+               error "failed mirror resync"
+       $LFS mirror split --mirror-id 1 -d $dom ||
+               error "failed mirror split"
+
+       [ $($LFS getstripe -L $dom) != 'mdt' ] ||
+               error "MDT stripe was not removed"
+
+       cancel_lru_locks mdc
+       local new_md5=$(md5sum $dom)
+       [ "$old_md5" == "$new_md5" ] ||
+               error "$old_md5 != $new_md5"
+
+       # Skip free space checks with ZFS
+       if [ "$(facet_fstype $facet)" != "zfs" ]; then
+               local mdtfree2=$(do_facet $facet \
+                               lctl get_param -n osd*.*$mdtname.kbytesfree)
+               [ $mdtfree2 -gt $mdtfree1 ] ||
+                       error "MDS space is not freed after DOM mirror deletion"
+       fi
+       return 0
+}
+run_test 272d "DoM mirroring: OST-striped mirror to DOM file"
+
+test_272e() {
+       [ $MDS1_VERSION -lt $(version_code 2.12.55) ] &&
+               skip "Need MDS version at least 2.12.55"
+
+       local dom=$DIR/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -c 2 $dom
+
+       dd if=/dev/urandom of=$dom bs=512K count=1 oflag=direct ||
+               error "failed to write data into $dom"
+       local old_md5=$(md5sum $dom)
+       cancel_lru_locks mdc
+
+       $LFS mirror extend -N -E 1M -L mdt -E eof -c2 $dom ||
+               error "failed mirroring to the DOM layout"
+       $LFS mirror resync $dom ||
+               error "failed mirror resync"
+       $LFS mirror split --mirror-id 1 -d $dom ||
+               error "failed mirror split"
+
+       [ $($LFS getstripe -L $dom) != 'mdt' ] ||
+               error "MDT stripe was not removed"
+
+       cancel_lru_locks mdc
+       local new_md5=$(md5sum $dom)
+       [ "$old_md5" == "$new_md5" ] ||
+               error "$old_md5 != $new_md5"
+
+       return 0
+}
+run_test 272e "DoM mirroring: DOM mirror to the OST-striped file"
+
+test_272f() {
+       [ $MDS1_VERSION -lt $(version_code 2.12.55) ] &&
+               skip "Need MDS version at least 2.12.55"
+
+       local dom=$DIR/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       $LFS setstripe -c 2 $dom
+
+       dd if=/dev/urandom of=$dom bs=512K count=1 oflag=direct ||
+               error "failed to write data into $dom"
+       local old_md5=$(md5sum $dom)
+       cancel_lru_locks mdc
+
+       $LFS migrate -E 1M -L mdt -E eof -c2 -v $dom ||
+               error "failed migrating to the DOM file"
+
+       cancel_lru_locks mdc
+       local new_md5=$(md5sum $dom)
+       [ "$old_md5" != "$new_md5" ] &&
+               error "$old_md5 != $new_md5"
+
+       return 0
+}
+run_test 272f "DoM migration: OST-striped file to DOM file"
+
 test_273a() {
        [ $MDS1_VERSION -lt $(version_code 2.11.50) ] &&
                skip "Need MDS version at least 2.11.50"
@@ -18299,6 +19014,48 @@ test_276() {
 }
 run_test 276 "Race between mount and obd_statfs"
 
+test_277() {
+       $LCTL set_param ldlm.namespaces.*.lru_size=0
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1
+       local cached_mb=$($LCTL get_param llite.*.max_cached_mb |
+                       grep ^used_mb | awk '{print $2}')
+       [ $cached_mb -eq 1 ] || error "expected mb 1 got $cached_mb"
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 \
+               oflag=direct conv=notrunc
+       cached_mb=$($LCTL get_param llite.*.max_cached_mb |
+                       grep ^used_mb | awk '{print $2}')
+       [ $cached_mb -eq 0 ] || error "expected mb 0 got $cached_mb"
+}
+run_test 277 "Direct IO shall drop page cache"
+
+test_278() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+       [[ "$(facet_host mds1)" != "$(facet_host mds2)" ]] &&
+               skip "needs the same host for mdt1 mdt2" && return
+
+       local pid1
+       local pid2
+
+#define OBD_FAIL_OBD_STOP_MDS_RACE     0x60b
+       do_facet mds2 $LCTL set_param fail_loc=0x8000060c
+       stop mds2 &
+       pid2=$!
+
+       stop mds1
+
+       echo "Starting MDTs"
+       start mds1 $(mdsdevname 1) $MDS_MOUNT_OPTS
+       wait $pid2
+#For the error assertion will happen. lu_env_get_key(..., &mdt_thread_key)
+#will return NULL
+       do_facet mds2 $LCTL set_param fail_loc=0
+
+       start mds2 $(mdsdevname 2) $MDS_MOUNT_OPTS
+       wait_recovery_complete mds2
+}
+run_test 278 "Race starting MDS between MDTs stop/start"
+
 cleanup_test_300() {
        trap 0
        umask $SAVE_UMASK
@@ -19312,14 +20069,13 @@ run_test 316 "lfs mv"
 test_317() {
        [ $MDS1_VERSION -lt $(version_code 2.11.53) ] &&
                skip "Need MDS version at least 2.11.53"
+       if [ "$ost1_FSTYPE" == "zfs" ]; then
+               skip "LU-10370: no implementation for ZFS"
+       fi
+
        local trunc_sz
        local grant_blk_size
 
-       if [ "$(facet_fstype $facet)" == "zfs" ]; then
-               skip "LU-10370: no implementation for ZFS" && return
-       fi
-
-       stack_trap "rm -f $DIR/$tfile" EXIT
        grant_blk_size=$($LCTL get_param osc.$FSNAME*.import |
                        awk '/grant_block_size:/ { print $2; exit; }')
        #
@@ -19327,7 +20083,8 @@ test_317() {
        # blocks count.
        #
        dd if=/dev/zero of=$DIR/$tfile bs=5M count=1 conv=fsync ||
-               error "Create file : $DIR/$tfile"
+               error "Create file $DIR/$tfile failed"
+       stack_trap "rm -f $DIR/$tfile" EXIT
 
        for trunc_sz in 2097152 4097 4000 509 0; do
                $TRUNCATE $DIR/$tfile $trunc_sz ||
@@ -19775,9 +20532,6 @@ test_406() {
        local def_stripe_size=$($LFS getstripe -S $MOUNT)
        local test_pool=$TESTNAME
 
-       if ! combined_mgs_mds ; then
-               mount_mgs_client
-       fi
        pool_add $test_pool || error "pool_add failed"
        pool_add_targets $test_pool 0 $(($OSTCOUNT - 1)) 1 ||
                error "pool_add_targets failed"
@@ -19830,10 +20584,6 @@ test_406() {
        local f=$DIR/$tdir/$tfile
        pool_remove_all_targets $test_pool $f
        pool_remove $test_pool $f
-
-       if ! combined_mgs_mds ; then
-               umount_mgs_client
-       fi
 }
 run_test 406 "DNE support fs default striping"
 
@@ -20039,10 +20789,12 @@ test_413b() {
        qos_prio_free=${qos_prio_free%%%}
        qos_threshold_rr=$($LCTL get_param -n lmv.*.qos_threshold_rr | head -n1)
        qos_threshold_rr=${qos_threshold_rr%%%}
+       qos_maxage=$($LCTL get_param -n lmv.*.qos_maxage)
 
        stack_trap "$LCTL set_param lmv.*.qos_prio_free=$qos_prio_free" EXIT
        stack_trap "$LCTL set_param lmv.*.qos_threshold_rr=$qos_threshold_rr" \
                EXIT
+       stack_trap "$LCTL set_param lmv.*.qos_maxage=$qos_maxage" EXIT
 
        echo "mkdir with roundrobin"
 
@@ -20060,59 +20812,61 @@ test_413b() {
        rm -rf $DIR/$tdir/*
 
        $LCTL set_param lmv.*.qos_threshold_rr=$qos_threshold_rr
+       # Shorten statfs result age, so that it can be updated in time
+       $LCTL set_param lmv.*.qos_maxage=1
+       sleep_maxage
 
        local ffree
+       local bavail
        local max
        local min
        local max_index
        local min_index
+       local tmp
 
-       ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.filesfree | uniq))
-       echo "MDT filesfree available: ${ffree[@]}"
-       max=${ffree[0]}
-       min=${ffree[0]}
+       ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.filesfree))
+       bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-[^M]*.kbytesavail))
+       bsize=$(lctl get_param -n mdc.*MDT0000*.blocksize)
+
+       max=$(((${ffree[0]} >> 8) * (${bavail[0]} * bsize >> 16)))
+       min=$(((${ffree[0]} >> 8) * (${bavail[0]} * bsize >> 16)))
        max_index=0
        min_index=0
-       for ((i = 0; i < ${#ffree[@]}; i++)); do
-               if [[ ${ffree[i]} -gt $max ]]; then
-                       max=${ffree[i]}
+       for ((i = 1; i < ${#ffree[@]}; i++)); do
+               tmp=$(((${ffree[i]} >> 8) * (${bavail[i]} * bsize >> 16)))
+               if [ $tmp -gt $max ]; then
+                       max=$tmp
                        max_index=$i
                fi
-               if [[ ${ffree[i]} -lt $min ]]; then
-                       min=${ffree[i]}
+               if [ $tmp -lt $min ]; then
+                       min=$tmp
                        min_index=$i
                fi
        done
-       echo "Min free files: MDT$min_index: $min"
-       echo "Max free files: MDT$max_index: $max"
 
-       [ $min -eq 0 ] && skip "no free files in MDT$min_index"
-       [ $min -gt 10000000 ] && skip "too much free files in MDT$min_index"
+       [ ${ffree[min_index]} -eq 0 ] &&
+               skip "no free files in MDT$min_index"
+       [ ${ffree[min_index]} -gt 100000000 ] &&
+               skip "too much free files in MDT$min_index"
 
        # Check if we need to generate uneven MDTs
-       test_mkdir -i $min_index -c 1 -p $DIR/$tdir-MDT$min_index
-       local threshold=10
-       local diff=$((max - min))
-       local diff2=$((diff * 100 / min))
-
-       echo -n "Check for uneven MDTs: "
-       echo -n "diff=$diff files ($diff2%) must be > $threshold% ..."
+       local threshold=50
+       local diff=$(((max - min ) * 100 / min))
+       local value="$(generate_string 1024)"
+       local i
 
-       if [ $diff2 -gt $threshold ]; then
-               echo "ok"
-               echo "Don't need to fill MDT$min_index"
-       else
-               # generate uneven MDTs, create till 25% diff
-               echo "no"
-               diff2=$((threshold - diff2))
-               diff=$((min * diff2 / 100))
+       while [ $diff -lt $threshold ]; do
+               # generate uneven MDTs, create till $threshold% diff
+               echo -n "weight diff=$diff% must be > $threshold% ..."
+               count=$((${ffree[min_index]} / 10))
                # 50 sec per 10000 files in vm
-               [ $diff -gt 40000 ] && [ "$SLOW" = "no" ] &&
-                       skip "$diff files to create"
-               echo "Fill $diff2% diff in MDT$min_index with $diff files"
-               local i
-               local value="$(generate_string 1024)"
-               for i in $(seq $diff); do
+               [ $count -gt 40000 ] && [ "$SLOW" = "no" ] &&
+                       skip "$count files to create"
+               echo "Fill MDT$min_index with $count files"
+               [ -d $DIR/$tdir-MDT$min_index ] ||
+                       $LFS mkdir -i $min_index $DIR/$tdir-MDT$min_index ||
+                       error "mkdir $tdir-MDT$min_index failed"
+               for i in $(seq $count); do
                        $OPENFILE -f O_CREAT:O_LOV_DELAY_CREATE \
                                $DIR/$tdir-MDT$min_index/f$i > /dev/null ||
                                error "create f$i failed"
@@ -20120,31 +20874,43 @@ test_413b() {
                                $DIR/$tdir-MDT$min_index/f$i ||
                                error "setfattr f$i failed"
                done
-       fi
 
-       min=$((100 *MDSCOUNT))
-       max=0
+               ffree=($(lctl get_param -n mdc.*[mM][dD][cC]-*.filesfree))
+               bavail=($(lctl get_param -n mdc.*[mM][dD][cC]-*.kbytesavail))
+               max=$(((${ffree[max_index]} >> 8) * \
+                       (${bavail[max_index]} * bsize >> 16)))
+               min=$(((${ffree[min_index]} >> 8) * \
+                       (${bavail[min_index]} * bsize >> 16)))
+               diff=$(((max - min) * 100 / min))
+       done
+
+       echo "MDT filesfree available: ${ffree[@]}"
+       echo "MDT blocks available: ${bavail[@]}"
+       echo "weight diff=$diff%"
 
        echo "mkdir with balanced space usage"
        $LCTL set_param lmv.*.qos_prio_free=100
        for i in $(seq $((100 * MDSCOUNT))); do
                mkdir $DIR/$tdir/subdir$i || error "mkdir subdir$i failed"
        done
+
        for i in $(seq $MDSCOUNT); do
                count=$($LFS getdirstripe -i $DIR/$tdir/* | grep ^$((i - 1))$ |
                        wc -w)
                echo "$count directories created on MDT$((i - 1))"
-               [ $min -gt $count ] && min=$count
-               [ $max -lt $count ] && max=$count
        done
-       [ $((max - min)) -gt $MDSCOUNT ] ||
+
+       max=$($LFS getdirstripe -i $DIR/$tdir/* | grep ^$max_index$ | wc -l)
+       min=$($LFS getdirstripe -i $DIR/$tdir/* | grep ^$min_index$ | wc -l)
+
+       [ $((max - min)) -lt 10 ] &&
                error "subdirs shouldn't be evenly distributed"
 
        which getfattr > /dev/null 2>&1 || skip_env "no getfattr command"
 
        $LFS setdirstripe -D -d $DIR/$tdir || error "setdirstripe -d failed"
-       getfattr -n trusted.dmv $DIR/$tdir && error "default dir layout exists"
-       true
+       getfattr -n trusted.dmv $DIR/$tdir &&
+               error "default dir layout exists" || true
 }
 run_test 413b "mkdir with balanced space usage"
 
@@ -20382,6 +21148,274 @@ test_420()
 }
 run_test 420 "clear SGID bit on non-directories for non-members"
 
+test_421a() {
+       local cnt
+       local fid1
+       local fid2
+
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       test_mkdir $DIR/$tdir
+       createmany -o $DIR/$tdir/f 3
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 3 ] && error "unexpected #files: $cnt"
+
+       fid1=$(lfs path2fid $DIR/$tdir/f1)
+       fid2=$(lfs path2fid $DIR/$tdir/f2)
+       $LFS rmfid $DIR $fid1 $fid2 || error "rmfid failed"
+
+       stat $DIR/$tdir/f1 && error "f1 still visible on the client"
+       stat $DIR/$tdir/f2 && error "f2 still visible on the client"
+
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt == 1 ] || error "unexpected #files after: $cnt"
+
+       rm -f $DIR/$tdir/f3 || error "can't remove f3"
+       createmany -o $DIR/$tdir/f 3
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 3 ] && error "unexpected #files: $cnt"
+
+       fid1=$(lfs path2fid $DIR/$tdir/f1)
+       fid2=$(lfs path2fid $DIR/$tdir/f2)
+       echo "remove using fsname $FSNAME"
+       $LFS rmfid $FSNAME $fid1 $fid2 || error "rmfid with fsname failed"
+
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt == 1 ] || error "unexpected #files after: $cnt"
+}
+run_test 421a "simple rm by fid"
+
+test_421b() {
+       local cnt
+       local FID1
+       local FID2
+
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       test_mkdir $DIR/$tdir
+       createmany -o $DIR/$tdir/f 3
+       multiop_bg_pause $DIR/$tdir/f1 o_c || error "multiop failed to start"
+       MULTIPID=$!
+
+       FID1=$(lfs path2fid $DIR/$tdir/f1)
+       FID2=$(lfs path2fid $DIR/$tdir/f2)
+       $LFS rmfid $DIR $FID1 $FID2 && error "rmfid didn't fail"
+
+       kill -USR1 $MULTIPID
+       wait
+
+       cnt=$(ls $DIR/$tdir | wc -l)
+       [ $cnt == 2 ] || error "unexpected #files after: $cnt"
+}
+run_test 421b "rm by fid on open file"
+
+test_421c() {
+       local cnt
+       local FIDS
+
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       test_mkdir $DIR/$tdir
+       createmany -o $DIR/$tdir/f 3
+       touch $DIR/$tdir/$tfile
+       createmany -l$DIR/$tdir/$tfile $DIR/$tdir/h 180
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 184 ] && error "unexpected #files: $cnt"
+
+       FID1=$(lfs path2fid $DIR/$tdir/$tfile)
+       $LFS rmfid $DIR $FID1 || error "rmfid failed"
+
+       cnt=$(ls $DIR/$tdir | wc -l)
+       [ $cnt == 3 ] || error "unexpected #files after: $cnt"
+}
+run_test 421c "rm by fid against hardlinked files"
+
+test_421d() {
+       local cnt
+       local FIDS
+
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       test_mkdir $DIR/$tdir
+       createmany -o $DIR/$tdir/f 4097
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 4097 ] && error "unexpected #files: $cnt"
+
+       FIDS=$(lfs path2fid $DIR/$tdir/f* | sed "s/[/][^:]*://g")
+       $LFS rmfid $DIR $FIDS || error "rmfid failed"
+
+       cnt=$(ls $DIR/$tdir | wc -l)
+       rm -rf $DIR/$tdir
+       [ $cnt == 0 ] || error "unexpected #files after: $cnt"
+}
+run_test 421d "rmfid en masse"
+
+test_421e() {
+       local cnt
+       local FID
+
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       mkdir -p $DIR/$tdir
+       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       createmany -o $DIR/$tdir/striped_dir/f 512
+       cnt=$(ls -1 $DIR/$tdir/striped_dir | wc -l)
+       [ $cnt != 512 ] && error "unexpected #files: $cnt"
+
+       FIDS=$(lfs path2fid $DIR/$tdir/striped_dir/f* |
+               sed "s/[/][^:]*://g")
+       $LFS rmfid $DIR $FIDS || error "rmfid failed"
+
+       cnt=$(ls $DIR/$tdir/striped_dir | wc -l)
+       rm -rf $DIR/$tdir
+       [ $cnt == 0 ] || error "unexpected #files after: $cnt"
+}
+run_test 421e "rmfid in DNE"
+
+test_421f() {
+       local cnt
+       local FID
+
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       test_mkdir $DIR/$tdir
+       touch $DIR/$tdir/f
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 1 ] && error "unexpected #files: $cnt"
+
+       FID=$(lfs path2fid $DIR/$tdir/f)
+       $RUNAS $LFS rmfid $DIR $FID && error "rmfid didn't fail (1)"
+       # rmfid should fail
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 1 ] && error "unexpected #files after (2): $cnt"
+
+       chmod a+rw $DIR/$tdir
+       ls -la $DIR/$tdir
+       $RUNAS $LFS rmfid $DIR $FID && error "rmfid didn't fail (2)"
+       # rmfid should fail
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 1 ] && error "unexpected #files after (3): $cnt"
+
+       rm -f $DIR/$tdir/f
+       $RUNAS touch $DIR/$tdir/f
+       FID=$(lfs path2fid $DIR/$tdir/f)
+       echo "rmfid as root"
+       $LFS rmfid $DIR $FID || error "rmfid as root failed"
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt == 0 ] || error "unexpected #files after (4): $cnt"
+
+       rm -f $DIR/$tdir/f
+       $RUNAS touch $DIR/$tdir/f
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt != 1 ] && error "unexpected #files (4): $cnt"
+       FID=$(lfs path2fid $DIR/$tdir/f)
+       # rmfid w/o user_fid2path mount option should fail
+       $RUNAS $LFS rmfid $DIR $FID && error "rmfid didn't fail(3)"
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt == 1 ] || error "unexpected #files after (5): $cnt"
+
+       umount_client $MOUNT || error "failed to umount client"
+       mount_client $MOUNT "$MOUNT_OPTS,user_fid2path" ||
+               error "failed to mount client'"
+
+       $RUNAS $LFS rmfid $DIR $FID || error "rmfid failed"
+       # rmfid should succeed
+       cnt=$(ls -1 $DIR/$tdir | wc -l)
+       [ $cnt == 0 ] || error "unexpected #files after (6): $cnt"
+
+       # rmfid shouldn't allow to remove files due to dir's permission
+       chmod a+rwx $DIR/$tdir
+       touch $DIR/$tdir/f
+       ls -la $DIR/$tdir
+       FID=$(lfs path2fid $DIR/$tdir/f)
+       $RUNAS $LFS rmfid $DIR $FID && error "rmfid didn't fail"
+
+       umount_client $MOUNT || error "failed to umount client"
+       mount_client $MOUNT "$MOUNT_OPTS" ||
+               error "failed to mount client'"
+
+}
+run_test 421f "rmfid checks permissions"
+
+test_421g() {
+       local cnt
+       local FIDS
+
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -lt $(version_code 2.12.54) ] &&
+               skip "Need MDS version at least 2.12.54"
+
+       mkdir -p $DIR/$tdir
+       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       createmany -o $DIR/$tdir/striped_dir/f 512
+       cnt=$(ls -1 $DIR/$tdir/striped_dir | wc -l)
+       [ $cnt != 512 ] && error "unexpected #files: $cnt"
+
+       FIDS=$(lfs path2fid $DIR/$tdir/striped_dir/f* |
+               sed "s/[/][^:]*://g")
+
+       rm -f $DIR/$tdir/striped_dir/f1*
+       cnt=$(ls -1 $DIR/$tdir/striped_dir | wc -l)
+       removed=$((512 - cnt))
+
+       # few files have been just removed, so we expect
+       # rmfid to fail on their fids
+       errors=$($LFS rmfid $DIR $FIDS 2>&1 | wc -l)
+       [ $removed != $errors ] && error "$errors != $removed"
+
+       cnt=$(ls $DIR/$tdir/striped_dir | wc -l)
+       rm -rf $DIR/$tdir
+       [ $cnt == 0 ] || error "unexpected #files after: $cnt"
+}
+run_test 421g "rmfid to return errors properly"
+
+test_422() {
+       test_mkdir -i 0 -c 1 -p $DIR/$tdir/d1
+       test_mkdir -i 0 -c 1 -p $DIR/$tdir/d2
+       test_mkdir -i 0 -c 1 -p $DIR/$tdir/d3
+       dd if=/dev/zero of=$DIR/$tdir/d1/file1 bs=1k count=1
+       dd if=/dev/zero of=$DIR/$tdir/d2/file1 bs=1k count=1
+
+       local amc=$(at_max_get client)
+       local amo=$(at_max_get mds1)
+       local timeout=`lctl get_param -n timeout`
+
+       at_max_set 0 client
+       at_max_set 0 mds1
+
+#define OBD_FAIL_PTLRPC_PAUSE_REQ        0x50a
+       do_facet mds1 $LCTL set_param fail_loc=0x8000050a \
+                       fail_val=$(((2*timeout + 10)*1000))
+       touch $DIR/$tdir/d3/file &
+       sleep 2
+#define OBD_FAIL_TGT_REPLY_DATA_RACE    0x722
+       do_facet mds1 $LCTL set_param fail_loc=0x80000722 \
+                       fail_val=$((2*timeout + 5))
+       mv $DIR/$tdir/d1/file1 $DIR/$tdir/d1/file2 &
+       local pid=$!
+       sleep 1
+       kill -9 $pid
+       sleep $((2 * timeout))
+       echo kill $pid
+       kill -9 $pid
+       lctl mark touch
+       touch $DIR/$tdir/d2/file3
+       touch $DIR/$tdir/d2/file4
+       touch $DIR/$tdir/d2/file5
+
+       wait
+       at_max_set $amc client
+       at_max_set $amo mds1
+}
+run_test 422 "kill a process with RPC in progress"
+
 prep_801() {
        [[ $(lustre_version_code mds1) -lt $(version_code 2.9.55) ]] ||
        [[ $OST1_VERSION -lt $(version_code 2.9.55) ]] &&
@@ -20424,7 +21458,8 @@ test_801a() {
        echo "Start barrier_freeze at: $(date)"
        #define OBD_FAIL_BARRIER_DELAY          0x2202
        do_facet mgs $LCTL set_param fail_val=5 fail_loc=0x2202
-       do_facet mgs $LCTL barrier_freeze $FSNAME 10 &
+       # Do not reduce barrier time - See LU-11873
+       do_facet mgs $LCTL barrier_freeze $FSNAME 20 &
 
        sleep 2
        local b_status=$(barrier_stat)
@@ -20446,7 +21481,8 @@ test_801a() {
        [ "$b_status" = "'expired'" ] ||
                error "(3) unexpected barrier status $b_status"
 
-       do_facet mgs $LCTL barrier_freeze $FSNAME 10 ||
+       # Do not reduce barrier time - See LU-11873
+       do_facet mgs $LCTL barrier_freeze $FSNAME 20 ||
                error "(4) fail to freeze barrier"
 
        b_status=$(barrier_stat)
@@ -20571,7 +21607,8 @@ test_801c() {
        do_facet mgs $LCTL barrier_rescan $FSNAME ||
                error "(3) Fail to rescan barrier bitmap"
 
-       do_facet mgs $LCTL barrier_freeze $FSNAME 10
+       # Do not reduce barrier time - See LU-11873
+       do_facet mgs $LCTL barrier_freeze $FSNAME 20
 
        b_status=$(barrier_stat)
        [ "$b_status" = "'frozen'" ] ||
@@ -20596,6 +21633,7 @@ run_test 801c "rescan barrier bitmap"
 saved_MGS_MOUNT_OPTS=$MGS_MOUNT_OPTS
 saved_MDS_MOUNT_OPTS=$MDS_MOUNT_OPTS
 saved_OST_MOUNT_OPTS=$OST_MOUNT_OPTS
+saved_MOUNT_OPTS=$MOUNT_OPTS
 
 cleanup_802a() {
        trap 0
@@ -20604,11 +21642,12 @@ cleanup_802a() {
        MGS_MOUNT_OPTS=$saved_MGS_MOUNT_OPTS
        MDS_MOUNT_OPTS=$saved_MDS_MOUNT_OPTS
        OST_MOUNT_OPTS=$saved_OST_MOUNT_OPTS
+       MOUNT_OPTS=$saved_MOUNT_OPTS
        setupall
 }
 
 test_802a() {
-
+       [[ $mds1_FSTYPE = zfs ]] || skip "ZFS specific test"
        [[ $(lustre_version_code mds1) -lt $(version_code 2.9.55) ]] ||
        [[ $OST1_VERSION -lt $(version_code 2.9.55) ]] &&
                skip "Need server version at least 2.9.55"
@@ -20639,7 +21678,8 @@ test_802a() {
                error "(4) Mount client without 'ro' should fail"
 
        echo "Mount client with ro should succeed"
-       mount_client $MOUNT ro ||
+       MOUNT_OPTS=$(csa_add "$MOUNT_OPTS" -o ro)
+       mount_client $MOUNT ||
                error "(5) Mount client with 'ro' should succeed"
 
        echo "Modify should be refused"
@@ -20933,7 +21973,7 @@ test_806() {
        done
        check_lsom_size $DIR/$tfile $size
 
-       # multi-client wirtes
+       # multi-client writes
        num=$(get_node_count ${CLIENTS//,/ })
        size=$(($num * $bs))
        offset=0
@@ -21098,20 +22138,29 @@ test_809() {
 run_test 809 "Verify no SOM xattr store for DoM-only files"
 
 test_810() {
-       local ORIG
-       local CSUM
-
-       # t10 seem to dislike partial pages
-       lctl set_param osc.*.checksum_type=adler
-       lctl set_param fail_loc=0x411
-       dd if=/dev/urandom of=$DIR/$tfile bs=10240 count=2
-       ORIG=$(md5sum $DIR/$tfile)
-       lctl set_param ldlm.namespaces.*osc*.lru_size=clear
-       CSUM=$(md5sum $DIR/$tfile)
-       set_checksum_type adler
-       if [ "$ORIG" != "$CSUM" ]; then
-               error "$ORIG != $CSUM"
-       fi
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       $GSS && skip_env "could not run with gss"
+
+       set_checksums 1
+       stack_trap "set_checksums $ORIG_CSUM" EXIT
+       stack_trap "set_checksum_type $ORIG_CSUM_TYPE" EXIT
+
+       local csum
+       local before
+       local after
+       for csum in $CKSUM_TYPES; do
+               #define OBD_FAIL_OSC_NO_GRANT   0x411
+               $LCTL set_param osc.*.checksum_type=$csum fail_loc=0x411
+               for i in "10240 0" "10000 0" "4000 1" "500 1"; do
+                       eval set -- $i
+                       dd if=/dev/urandom of=$DIR/$tfile bs=$1 count=2 seek=$2
+                       before=$(md5sum $DIR/$tfile)
+                       $LCTL set_param ldlm.namespaces.*osc*.lru_size=clear
+                       after=$(md5sum $DIR/$tfile)
+                       [ "$before" == "$after" ] ||
+                               error "$csum: $before != $after bs=$1 seek=$2"
+               done
+       done
 }
 run_test 810 "partial page writes on ZFS (LU-11663)"
 
@@ -21335,6 +22384,94 @@ test_814()
 }
 run_test 814 "sparse cp works as expected (LU-12361)"
 
+test_815()
+{
+       writeme -b 100 $DIR/$tfile || error "write 100 bytes failed"
+       writeme -b 0 $DIR/$tfile || error "write 0 byte failed"
+}
+run_test 815 "zero byte tiny write doesn't hang (LU-12382)"
+
+test_816() {
+       [ "$SHARED_KEY" = true ] &&
+               skip "OSC connections never go IDLE with Shared-Keys enabled"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile
+       # ensure ost1 is connected
+       stat $DIR/$tfile >/dev/null || error "can't stat"
+       wait_osc_import_state client ost1 FULL
+       # no locks, no reqs to let the connection idle
+       cancel_lru_locks osc
+       lru_resize_disable osc
+       local before
+       local now
+       before=$($LCTL get_param -n \
+                ldlm.namespaces.$FSNAME-OST0000-osc-[^M]*.lru_size)
+
+       wait_osc_import_state client ost1 IDLE
+       dd if=/dev/null of=$DIR/$tfile bs=1k count=1 conv=sync
+       now=$($LCTL get_param -n \
+             ldlm.namespaces.$FSNAME-OST0000-osc-[^M]*.lru_size)
+       [ $before == $now ] || error "lru_size changed $before != $now"
+}
+run_test 816 "do not reset lru_resize on idle reconnect"
+
+cleanup_817() {
+       umount $tmpdir
+       exportfs -u localhost:$DIR/nfsexp
+       rm -rf $DIR/nfsexp
+}
+
+test_817() {
+       systemctl restart nfs-server.service || skip "failed to restart nfsd"
+
+       mkdir -p $DIR/nfsexp
+       exportfs -orw,no_root_squash localhost:$DIR/nfsexp ||
+               error "failed to export nfs"
+
+       tmpdir=$(mktemp -d /tmp/nfs-XXXXXX)
+       stack_trap cleanup_817 EXIT
+
+       mount -t nfs -orw localhost:$DIR/nfsexp $tmpdir ||
+               error "failed to mount nfs to $tmpdir"
+
+       cp /bin/true $tmpdir
+       $DIR/nfsexp/true || error "failed to execute 'true' command"
+}
+run_test 817 "nfsd won't cache write lock for exec file"
+
+test_818() {
+       mkdir $DIR/$tdir
+       $LFS setstripe -c1 -i0 $DIR/$tfile
+       $LFS setstripe -c1 -i1 $DIR/$tfile
+       stop $SINGLEMDS
+       #define OBD_FAIL_OSP_CANT_PROCESS_LLOG          0x2105
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80002105
+       start $SINGLEMDS $(mdsdevname ${SINGLEMDS//mds/}) $MDS_MOUNT_OPTS ||
+               error "start $SINGLEMDS failed"
+       rm -rf $DIR/$tdir
+}
+run_test 818 "unlink with failed llog"
+
+test_819a() {
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1
+       cancel_lru_locks osc
+       #define OBD_FAIL_OST_2BIG_NIOBUF                0x248
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000248
+       dd if=$DIR/$tfile of=/dev/null bs=1M count=1
+       rm -f $TDIR/$tfile
+}
+run_test 819a "too big niobuf in read"
+
+test_819b() {
+       #define OBD_FAIL_OST_2BIG_NIOBUF                0x248
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x80000248
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1
+       cancel_lru_locks osc
+       sleep 1
+       rm -f $TDIR/$tfile
+}
+run_test 819b "too big niobuf in write"
+
 #
 # tests that do cleanup/setup should be run at the end
 #